﻿Imports Telerik.Web.UI
Imports System.Data.SqlClient
Imports System.Data

Partial Class EmployeesGridVB
    Inherits System.Web.UI.UserControl
    Public ReadOnly Property EmployeesData() As DataSet
        Get
            Dim obj As Object = Me.Session("EmployeesData")
            If obj IsNot Nothing Then
                Return DirectCast(obj, DataSet)
            End If

            Dim _employeesData As New DataSet()

            Dim ConnString As [String] = ConfigurationManager.ConnectionStrings("NorthwindConnectionString").ConnectionString
            Dim conn As New SqlConnection(ConnString)
            Dim adapter As New SqlDataAdapter()
            adapter.SelectCommand = New SqlCommand("SELECT EmployeeID, FirstName, LastName, Title, TitleOfCourtesy, BirthDate, Notes FROM Employees", conn)

            adapter.Fill(_employeesData, "Employees")

            Me.Session("EmployeesData") = _employeesData

            Return _employeesData
        End Get
    End Property
    Protected Sub DisplayEditForm(ByVal selectedItem As GridDataItem)
        Me.Parent.FindControl("pnlExternalForm").Visible = True
        TryCast(Me.Parent.FindControl("btnDelete"), Button).Attributes("style") = "display: block"
        TryCast(Me.Parent.FindControl("btnDelete"), Button).Attributes("style") = "float: right; margin-right: 10px; color: black; font-weight: bold;"
        TryCast(Me.Parent.FindControl("btnSaveChanges"), Button).Text = "Update"

        TryCast(Me.Parent.FindControl("EmployeeID"), Label).Text = selectedItem("EmployeeID").Text
        TryCast(Me.Parent.FindControl("FirstName"), RadTextBox).Text = selectedItem("FirstName").Text
        TryCast(Me.Parent.FindControl("LastName"), RadTextBox).Text = selectedItem("LastName").Text
        TryCast(Me.Parent.FindControl("Title1"), RadTextBox).Text = selectedItem("Title").Text

        TryCast(Me.Parent.FindControl("TitleOfCourtesy"), RadComboBox).FindItemByText(selectedItem("TitleOfCourtesy").Text).Selected = True
        TryCast(Me.Parent.FindControl("BirthDate"), RadDatePicker).SelectedDate = DateTime.Parse(selectedItem("BirthDate").Text)

        TryCast(Me.Parent.FindControl("Notes"), RadEditor).Content = selectedItem("Notes").Text
    End Sub
    Protected Sub DisplayInsertForm()
        Me.Parent.FindControl("pnlExternalForm").Visible = True
        TryCast(Me.Parent.FindControl("btnDelete"), Button).Attributes("style") = "display: none"
        TryCast(Me.Parent.FindControl("btnSaveChanges"), Button).Text = "Insert"

        TryCast(Me.Parent.FindControl("EmployeeID"), Label).Text = String.Empty
        TryCast(Me.Parent.FindControl("FirstName"), RadTextBox).Text = String.Empty
        TryCast(Me.Parent.FindControl("LastName"), RadTextBox).Text = String.Empty
        TryCast(Me.Parent.FindControl("Title1"), RadTextBox).Text = String.Empty

        TryCast(Me.Parent.FindControl("TitleOfCourtesy"), RadComboBox).SelectedIndex = 0
        TryCast(Me.Parent.FindControl("BirthDate"), RadDatePicker).SelectedDate = Nothing

        TryCast(Me.Parent.FindControl("Notes"), RadEditor).Content = String.Empty
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        RadAjaxManager.GetCurrent(Page).AjaxSettings.AddAjaxSetting(RadGrid1, RadGrid1, TryCast(Me.Parent.FindControl("RadAjaxLoadingPanel1"), RadAjaxLoadingPanel))
        'store the clientID of the grid to reference it later on the client
        RadAjaxManager.GetCurrent(Page).ResponseScripts.Add(String.Format("window['gridId'] = '{0}';", RadGrid1.ClientID))
    End Sub
    Protected Sub RadGrid1_ColumnCreated(ByVal sender As Object, ByVal e As GridColumnCreatedEventArgs)
        If e.Column.IsBoundToFieldName("BirthDate") Then
            DirectCast(e.Column, GridBoundColumn).DataFormatString = "{0:MM/dd/yyyy}"
        ElseIf e.Column.IsBoundToFieldName("Notes") OrElse e.Column.IsBoundToFieldName("EmployeeID") Then
            e.Column.Visible = False
        End If
    End Sub
    Protected Sub RadGrid1_ItemCreated(ByVal sender As Object, ByVal e As GridItemEventArgs)
        If TypeOf e.Item Is GridDataItem Then
            Dim editButton As ImageButton = TryCast(TryCast(e.Item, GridDataItem)("EditColumn").Controls(0), ImageButton)
            RadAjaxManager.GetCurrent(Page).AjaxSettings.AddAjaxSetting(editButton, Me.Parent.FindControl("DivExternalForm"), TryCast(Me.Parent.FindControl("RadAjaxLoadingPanel1"), RadAjaxLoadingPanel))
        ElseIf TypeOf e.Item Is GridCommandItem Then
            Dim insertButton As LinkButton = TryCast(TryCast(e.Item, GridCommandItem).FindControl("btnInitInsert"), LinkButton)
            RadAjaxManager.GetCurrent(Page).AjaxSettings.AddAjaxSetting(insertButton, Me.Parent.FindControl("DivExternalForm"), TryCast(Me.Parent.FindControl("RadAjaxLoadingPanel1"), RadAjaxLoadingPanel))
        End If
    End Sub
    Protected Sub RadGrid1_NeedDataSource(ByVal sender As Object, ByVal e As GridNeedDataSourceEventArgs)
        Me.RadGrid1.DataSource = Me.EmployeesData
        Me.EmployeesData.Tables("Employees").PrimaryKey = New DataColumn() {Me.EmployeesData.Tables("Employees").Columns("EmployeeID")}
    End Sub
    Protected Sub RadGrid1_ItemCommand(ByVal sender As Object, ByVal e As GridCommandEventArgs)
        Select Case e.CommandName
            'cancel default edit command and load the edited data in the external form
            Case RadGrid.EditCommandName
                e.Canceled = True
                e.Item.Selected = True
                DisplayEditForm(TryCast(e.Item, GridDataItem))
                Exit Select
                'cancel the default insert command and display the external insert form
            Case RadGrid.InitInsertCommandName
                e.Canceled = True
                RadGrid1.SelectedIndexes.Clear()
                DisplayInsertForm()
                Exit Select
            Case Else
                Exit Select
        End Select
    End Sub
    Protected Sub RadGrid1_UpdateCommand(ByVal source As Object, ByVal e As Telerik.Web.UI.GridCommandEventArgs)
        'cancel the default action
        e.Canceled = True
        Dim employeesTable As DataTable = Me.EmployeesData.Tables("Employees")

        For Each column As DataColumn In employeesTable.Columns
            Try
                Dim changedRows As DataRow() = employeesTable.[Select]("EmployeeID = " + TryCast(RadGrid1.SelectedItems(0), GridDataItem).GetDataKeyValue("EmployeeID").ToString())

                Select Case column.ColumnName
                    Case "FirstName"
                        changedRows(0)(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadTextBox).Text
                        Exit Select
                    Case "LastName"
                        changedRows(0)(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadTextBox).Text
                        Exit Select
                    Case "Title"
                        changedRows(0)(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName & "1"), RadTextBox).Text
                        Exit Select
                    Case "TitleOfCourtesy"
                        changedRows(0)(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadComboBox).SelectedValue
                        Exit Select
                    Case "BirthDate"
                        changedRows(0)(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadDatePicker).SelectedDate
                        Exit Select
                    Case "Notes"
                        changedRows(0)(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadEditor).Content
                        Exit Select
                    Case Else
                        Exit Select

                End Select
                Me.EmployeesData.Tables("Employees").AcceptChanges()
            Catch ex As Exception
                RadGrid1.Controls.Add(New LiteralControl("<strong>Unable to set value of column '" + column.ColumnName + "'</strong> - " + ex.Message))
                e.Canceled = True
                Exit Try
            End Try
        Next

        e.Item.OwnerTableView.Rebind()
        e.Item.Selected = True

        Me.Parent.FindControl("pnlExternalForm").Visible = False

    End Sub
    Protected Sub RadGrid1_InsertCommand(ByVal source As Object, ByVal e As GridCommandEventArgs)
        Dim employeesTable As DataTable = Me.EmployeesData.Tables("Employees")

        Dim newRow As DataRow = employeesTable.NewRow()

        'Set new values
        For Each column As DataColumn In employeesTable.Columns
            Try
                Select Case column.ColumnName
                    Case "FirstName"
                        newRow(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadTextBox).Text
                        Exit Select
                    Case "LastName"
                        newRow(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadTextBox).Text
                        Exit Select
                    Case "Title"
                        newRow(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName & "1"), RadTextBox).Text
                        Exit Select
                    Case "TitleOfCourtesy"
                        newRow(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadComboBox).SelectedValue
                        Exit Select
                    Case "BirthDate"
                        newRow(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadDatePicker).SelectedDate
                        Exit Select
                    Case "Notes"
                        newRow(column.ColumnName) = TryCast(Me.Parent.FindControl(column.ColumnName), RadEditor).Content
                        Exit Select
                    Case Else
                        Exit Select

                End Select
            Catch ex As Exception
                RadGrid1.Controls.Add(New LiteralControl("Unable to insert into Employees. Reason: " + ex.Message))
                e.Canceled = True
            End Try
        Next
        newRow("EmployeeID") = CInt(employeesTable.Rows(employeesTable.Rows.Count - 1)("EmployeeID")) + 1

        employeesTable.Rows.Add(newRow)
        Me.EmployeesData.Tables("Employees").AcceptChanges()

        Me.Parent.FindControl("pnlExternalForm").Visible = False
    End Sub
    Protected Sub RadGrid1_DeleteCommand(ByVal source As Object, ByVal e As GridCommandEventArgs)
        Dim ID As String = TryCast(RadGrid1.SelectedItems(0), GridDataItem).GetDataKeyValue("EmployeeID").ToString()
        Dim employeeTable As DataTable = Me.EmployeesData.Tables("Employees")

        If employeeTable.Rows.Find(ID) IsNot Nothing Then
            employeeTable.Rows.Find(ID).Delete()
            employeeTable.AcceptChanges()
        End If
        Me.Parent.FindControl("pnlExternalForm").Visible = False
    End Sub


End Class
